SystemOrganization addCategory: #'ChisCommit-Core'!
SystemOrganization addCategory: #'ChisCommit-Core-Tests'!
SystemOrganization addCategory: #'ChisCommit-Examples'!
SystemOrganization addCategory: #'ChisCommit-GUI'!
SystemOrganization addCategory: #'ChisCommit-GUI-Tests'!
SystemOrganization addCategory: #'ChisCommit-Interactions'!
SystemOrganization addCategory: #'ChisCommit-Interactions-Tests'!

ROLayoutTranslator subclass: #CHSmoothLayoutTranslator
	instanceVariableNames: 'cycles move'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHSmoothLayoutTranslator class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:19'!
create: nCycles

	^self new cycles: nCycles.! !

!CHSmoothLayoutTranslator methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:18'!
cycles: nCycles

	cycles := nCycles.! !

!CHSmoothLayoutTranslator methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:18'!
translate: element to: newPosition
	move := ROLinearMove new
					nbCycles: cycles;
					for: element to: newPosition.! !

WizardControl subclass: #ChisWizzard
	instanceVariableNames: ''
	classVariableNames: 'PreviousAnalysis'
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!ChisWizzard class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 10:57'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'ChisCommit')
		order: 0.2; 
		parent: #Tools;
		label: 'ChisCommit';
		action:[ self open]! !

!ChisWizzard class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:08'!
open
	|wizard selectedPackages|
	wizard := self new open.
	wizard wizardInformations ifEmpty: [^ self ].
	(wizard wizardInformations includesKey: #packagesSelected) ifFalse: [^ self].
	selectedPackages := wizard wizardInformations at: #packagesSelected.
	selectedPackages ifEmpty: [ 
			UIManager default inform: 'No package has been selected'.
			^ self ].
	^ CHVersionVisualization analyzePackages: selectedPackages.! !

!ChisWizzard class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 10:12'!
title

	^'ChisCommit'.! !

!ChisWizzard methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 10:18'!
buildWizardControl
	"
	self new open
	"

	| panel part1 part2 |
	panel := WizardSinglePane new.

	self addPane: panel.
	
	part1 := TextPart new inGroupboxNamed: self class title, ': select the packages to analyze'.
	panel addPart: part1 associatedTo: #info.
	part2 := MultiSelectionItemSelectorPart new initialList: self packagesList.
	panel addPart: part2 associatedTo: #packagesSelected.! !

!ChisWizzard methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 10:12'!
initialize

	super initialize.
	self buildWizardControl.! !

!ChisWizzard methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 10:13'!
packagesList
	^ (PackageOrganizer default packageNames select: #isString) asSortedCollection: [ :a :b | a < b ]! !

!ROContainer methodsFor: '*chisCommit-GUI' stamp: 'AlejandroInfante 1/24/2013 10:12'!
removeAll: elementsCollection

	elementsCollection do: [:ea | self remove: ea ].! !

ROInteraction subclass: #CHInteraction
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

CHInteraction subclass: #CHChangeColorToAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHChangeColorToAuthor methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 11:59'!
initializeElement: element

	element on: ROMouseLeftClick do: [:event |
		|author commitsToChange|
		author := event element model author.
		commitsToChange := OrderedCollection new.
		controller methodsVisualization do: [ :eaMethod |
			commitsToChange addAll: (eaMethod elements select: [:eaCommit |
				eaCommit model author = author
				]).
		].
		commitsToChange do: #changeColor.
		].! !

CHInteraction subclass: #CHChangeColorToClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHChangeColorToClass methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 11:59'!
initializeElement: element

	element on: ROMouseLeftClick do: [:event |
		|class methodsToChange|
		class := event element model methodClass.
		methodsToChange := controller methodsVisualization select: [ :eaMethod |
			eaMethod model methodClass = class
		].
		methodsToChange do: #changeColor.
		].! !

!CHInteraction class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:40'!
initializeWithController: aController
	
	^self new controller: aController.! !

!CHInteraction methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:40'!
controller: aController

	controller := aController.! !

ROElement subclass: #CHLegendElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHLegendElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 16:25'!
create: aString color: aColor

	^self new label: aString color: aColor.! !

!CHLegendElement methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 16:33'!
label: aString color: aColor

	|box label|
	box := ROElement new + (ROBox new color: aColor).
	box size: 10.
	label := ROElement new + (ROLabel text: aString).
	self add: box.
	self add: label.
	ROHorizontalLineLayout new applyOn: elements.! !

ROElement subclass: #CHMenu
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHMenu subclass: #CHColorsMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHColorsMenu subclass: #CHAuthorColorsMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHAuthorColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:48'!
colorManager

	^controller authorColorManager.! !

!CHAuthorColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 09:49'!
tag

	^'Author Color'.! !

!CHAuthorColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:43'!
visit: aVisitor

	aVisitor visitAuthorColorsMenu: self.! !

CHColorsMenu subclass: #CHClassColorsMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHClassColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:42'!
colorManager

	^controller classColorManager.! !

!CHClassColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 09:49'!
tag

	^'Class Color'.! !

!CHClassColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:44'!
visit: aVisitor

	aVisitor visitClassColorsMenu: self.! !

!CHColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:40'!
colorManager

	self subclassResponsibility.! !

!CHColorsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:11'!
setUp

	super setUp.
	self add: (CHMenuButton create: 'Highlight All' command: (CHHighlightAllCommand create: self colorManager)).
	self add: (CHMenuButton create: 'Highlight None' command: (CHHighlightNoneCommand create: self colorManager)).
	self add: (CHMenuButton create: 'Shuffle Colors' command: (CHShuffleColorsCommand create: self colorManager)).
	self add: (CHMenuLegend create: self colorManager).
	ROVerticalLineLayout new applyOn: self elements.
	ROConstraint stick: self below: (controller menu detect: [:ea | ea model = self tag]).! !

CHMenu subclass: #CHFilterMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHFilterMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:11'!
setUp

	super setUp.
	self add: (CHToggleableMenuButton create: 'Filter Tests' command: 
		(CHFilterTestsCommand create: controller filterManager)).
	self add: (CHToggleableMenuButton create: 'Filter Highlighted' command: 		(CHFilterHighlightedCommand create: controller filterManager)).
	ROVerticalLineLayout new applyOn: self elements.
	ROConstraint stick: self below: (controller menu detect: [:ea | ea model = self tag]).! !

!CHFilterMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:10'!
tag

	^'Filter'.! !

!CHFilterMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:27'!
visit: aVisitor

	aVisitor visitFilterMenu: self.! !

CHMenu subclass: #CHInfoMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHInfoMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:15'!
info

	^
'Each horizontal bar represents a method, and each little square 
in a bar represent a new version in a method, this visualization has
a timescale in the x-axis so a version that apearsat the left, means 
that it was made before.
The clases can be colored individually by clicking on a method of the 
class or can be colored by the menu.
The versions can be colored individually by clicking on a version and 
it highlight all the versions made by the same author.
Actually the results can be filtered in the menu filtering all the test and
all the unhighlighted methods.'! !

!CHInfoMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:11'!
setUp

	super setUp.
	self add: (ROElement labelOn: self info).
	ROConstraint stick: self below: (controller menu detect: [:ea | ea model = self tag]).! !

!CHInfoMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:48'!
tag

	^'Info'.! !

!CHInfoMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:48'!
visit: aVisitor

	aVisitor visitInfoMenu: self.! !

!CHMenu class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 11:21'!
create: aController

	^(self new controller: aController) setUp.! !

!CHMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:22'!
changeMenu: aMenuClass

	self remove.
	controller activeMenu: (aMenuClass create: controller).
	controller rawView signalUpdate.
	! !

!CHMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:14'!
controller: aController

	controller := aController.! !

!CHMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:10'!
setUp

	self addShape: (ROBox new color: Color white).
	self addShape: (ROBorder new color: Color black).! !

!CHMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:09'!
tag

	self subclassResponsibility.! !

!CHMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:39'!
visit: anElement

	self subclassResponsibility.! !

CHMenu subclass: #CHNullMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHNullMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 11:25'!
setUp! !

!CHNullMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:10'!
tag

	^'NULL'.! !

!CHNullMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:39'!
visit: aVisitor

	aVisitor visitNullMenu: self.! !

CHMenu subclass: #CHSortElementsMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHSortElementsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 12:11'!
setUp

	super setUp.
	self add: (CHMenuButton create: 'Sort by Antique' command: (CHSortByAntiqueCommand create: controller)).
	self add: (CHMenuButton create: 'Sort by number of Commits' command: (CHSortByCommitsNumberCommand create: controller)).
	self add: (CHMenuButton create: 'Sort by Class' command: (CHSortByClassCommand create: controller ) ).
	ROVerticalLineLayout new applyOn: self elements.
	ROConstraint stick: self below: (controller menu detect: [:ea | ea model = self tag]).! !

!CHSortElementsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:18'!
tag

	^'Sort Elements'.! !

!CHSortElementsMenu methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:19'!
visit: aVisitor

	aVisitor visitSortElementsMenu: self.! !

ROElement subclass: #CHMenuElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHMenuElement subclass: #CHMenuButton
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHMenuButton class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:46'!
create: aString command: aCommand

	^self new label: aString command: aCommand.! !

!CHMenuButton methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:22'!
label: aString command: aCommand

	self addShape: (ROLabel text: aString).
	self on: ROMouseLeftClick do: [:event | aCommand execute.]! !

!CHMenuElement methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 11:54'!
initialize

	super initialize.
	self addShape: ROBorder new.! !

CHMenuElement subclass: #CHMenuLegend
	instanceVariableNames: 'colorManager highlightedKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHMenuLegend class
	instanceVariableNames: 'controller'!

CHMenuLegend class
	instanceVariableNames: 'controller'!

!CHMenuLegend class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 15:50'!
create: aColorManager

	^(self new colorManager: aColorManager) setUp.! !

!CHMenuLegend methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 15:50'!
colorManager: aColorManager

	colorManager := aColorManager.
	! !

!CHMenuLegend methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:07'!
setUp

	highlightedKeys := (colorManager highlightedColorStates collect: [:ea | colorManager getKey: ea parent ]).
	self addAll: (highlightedKeys collect: [:ea | CHLegendElement create: ea color: (colorManager colorForKey: ea)]).
	(ROVerticalLineLayout new gapSize: 1) applyOn: elements.
	! !

CHMenuElement subclass: #CHToggleableMenuButton
	instanceVariableNames: 'command state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHToggleableMenuButton class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:31'!
create: aString command: aRevertibleCommand

	^self new label: aString command: aRevertibleCommand.! !

!CHToggleableMenuButton methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:39'!
defaultState

	^ CHToogledOffState create: self.! !

!CHToggleableMenuButton methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:49'!
initialize

	super initialize.
	self state: self defaultState.! !

!CHToggleableMenuButton methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:49'!
label: aString command: aCommand

	self addShape: (ROLabel text: aString).
	self on: ROMouseLeftClick do: [:event | state changeState: aCommand.].
	aCommand isApplied ifTrue: [state changeState].! !

!CHToggleableMenuButton methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:05'!
state: aState

	state:= aState.
	self shapes do: [:ea | ea color: state color ].
	self view signalUpdate.! !

ROElement subclass: #CHTimeRuler
	instanceVariableNames: 'marks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHTimeRuler subclass: #CHHourTimeRuler
	instanceVariableNames: 'loopIndex labelModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHHourTimeRuler subclass: #CH12HourTimeRuler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 15:38'!
gap

	^12.! !

!CH12HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 09:49'!
setLabelModel

	labelModel := #('00:00' '12:00').! !

CHHourTimeRuler subclass: #CH6HourTimeRuler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CH6HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:05'!
gap

	^6.! !

!CH6HourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:06'!
setLabelModel

	labelModel := #('00:00' '06:00' '12:00' '18:00').! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:54'!
beginingDate

	|date|
	date := DateAndTime fromSeconds: (model minimumValue: 0).
	^ date asDate mmddyyyy, ' ', date asTime hours asString,':',date minutes asString.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:55'!
endingDate

	|date|
	date := DateAndTime fromSeconds: (model maximumValue: 0).
	^ date asDate mmddyyyy, ' ', date asTime hours asString,':',date minutes asString.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:02'!
initialize

	super initialize.
	loopIndex := 0.
	self setLabelModel.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:01'!
labelModel

	^labelModel.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:46'!
model: normalizer

	super model: normalizer.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:18'!
nextLabel

	|label|
	loopIndex := loopIndex + 1.
	label := self labelModel at: loopIndex.
	loopIndex := loopIndex \\ self labelModel size.
	^label! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:05'!
scale

	^3600.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:02'!
setLabelModel

	self subclassResponsibility.! !

!CHHourTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 18:01'!
setUpIteration
	
	|date|
	date := DateAndTime fromSeconds: (model minimumValue: 0).
	[date asTime hours > (self gap* (loopIndex))] whileTrue: [ loopIndex := loopIndex + 1].
	date := (DateAndTime date: date asDate time: (Time hour: self gap * loopIndex minute: 0 second: 0 )) 		asSeconds.
	loopIndex := loopIndex \\ self labelModel size.
	^date! !

!CHTimeRuler class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 15:33'!
create: methodNormalizer

	|elem|
	elem := self new.
	elem model: methodNormalizer.
	^elem.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:47'!
beginingDate

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:49'!
drawMarks

	|value|
	value := self setUpIteration.
	[value < (model maximumValue: 0)] whileTrue:[
		|mark label|
		mark := ROLabel elementOn: '|'.
		mark translateTo: ((model roValue: value) @ mark position y).
		marks add: mark.
		label := ROLabel elementOn: self nextLabel.
		ROConstraint stick: label below: mark.
		self add: mark; add: label.
		value := value + (self gap * self scale).
	].! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:55'!
endingDate

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:04'!
gap

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'initialization' stamp: 'AlejandroInfante 1/15/2013 09:37'!
initialize

	super initialize.
	marks := OrderedCollection new.
! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 18:04'!
marks

	^marks! !

!CHTimeRuler methodsFor: 'accessing' stamp: 'AlejandroInfante 1/14/2013 15:42'!
model: normalizer

	super model: normalizer.
	self drawMarks.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:27'!
nextLabel

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 17:04'!
scale

	self subclassResponsibility.! !

!CHTimeRuler methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 09:23'!
setUpIteration

	self subclassResponsibility .! !

ROElement subclass: #CHVersionElement
	instanceVariableNames: 'colorState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionElement commentStamp: '<historical>' prior: 0!
This is an abstract class that is the root of the visual elements displayed by Chisa, this class is a subclass from Roassals -> ROElement.!

CHVersionElement subclass: #CHCommitVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHCommitVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a commit, once instantiated it has everything it needs to displaying correctly.!

!CHCommitVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:45'!
defaultShape

	^ ROCircle new.! !

!CHCommitVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:34'!
model: aModel

	super model: aModel.
	self @ (ROPopup text: model asString ).! !

CHVersionElement subclass: #CHMethodVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a method, once instantiated it has everything it needs to displaying correctly, also is responsible about adding the commits on the visualization.!

!CHMethodVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:45'!
defaultShape

	^ ROBox new.! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/15/2013 14:38'!
drawCommits: builder

	self addAll: (model commitTimeStamps collect: [:commit | 
			builder buildCommitVisualization: commit]).! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/23/2013 18:17'!
model: aModel

	super model: aModel.
	self @ (ROPopup text: model asString ).! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 15:50'!
create: model

	|elem|
	elem := (self new model: model) addShape: self defaultShape.
	^elem.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:16'!
defaultShape

	^ self subclassResponsibility ! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:44'!
changeColor

	colorState changeColor.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:32'!
color: aColor

	self shapes do: [:ea | ea color: aColor ].
	self view signalUpdate.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/28/2013 12:56'!
colorState
	
	^colorState.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 11:05'!
colorState: aColorState

	colorState := aColorState.! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 11:33'!
model: newModel

	super model: newModel.
	self removeInteraction: ROInteraction.
	self resizeStrategy: ROFixedSizedParent instance.
	
	^self.! !

!ROAbstractComponent methodsFor: '*ChisCommit-GUI' stamp: 'AlejandroInfante 1/25/2013 10:43'!
removeFromView

	self view = self parent ifTrue: [
		self view remove: self.
		self removeFromParent.
		self parent: ROView nullView.
		].
	self view removeElementToRender: self.
	self allElementsDo: #removeFromView.
	self view: ROView nullView.! !

TestCase subclass: #CH12HourTimeRulerTest
	instanceVariableNames: 'normalizer ruler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CH12HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:11'!
setUp

	ruler := CH12HourTimeRuler create: CHTestUtils getInstance getTestNormalizer.! !

!CH12HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:08'!
testGap

	self assert:( ruler gap = 12).! !

!CH12HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:09'!
testLabelModel

	self assert:( ruler labelModel =  #('00:00' '12:00')).! !

TestCase subclass: #CH6HourTimeRulerTest
	instanceVariableNames: 'normalizer ruler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CH6HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:11'!
setUp

	ruler := CH6HourTimeRuler create: CHTestUtils getInstance getTestNormalizer.! !

!CH6HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:10'!
testGap

	self assert:( ruler gap = 6).! !

!CH6HourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 12:10'!
testLabelModel

	self assert:( ruler labelModel =  #('00:00' '06:00' '12:00' '18:00')).! !

TestCase subclass: #CHAuthorColorManagerTest
	instanceVariableNames: 'authorDict colorState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHAuthorColorManagerTest commentStamp: '<historical>' prior: 0!
A CHAuthorColorManagerTest is a test class for testing the behavior of CHAuthorColorManager!

!CHAuthorColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 15:03'!
setUp

	|stamps|
	stamps := OrderedCollection new.
	stamps add: (CHTimeStamp createFromString: 'AI 3/5/2013 11:56'); 
		add: (CHTimeStamp createFromString: 'AIn 3/5/2013 11:56'); 
		add: (CHTimeStamp createFromString: 'AI 3/5/2013 21:56').
	authorDict := CHAuthorColorManager create: (stamps collect: #author).
	colorState := authorDict getDefaultColorStateFor: (CHCommitVisualization  create: 		(CHTimeStamp createFromString: 'AI 3/5/2013 11:56') ).
	authorDict getDefaultColorStateFor: (CHCommitVisualization create: (CHTimeStamp 		createFromString: 'AIn 3/5/2013 11:56')).! !

!CHAuthorColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 15:04'!
testHighlightAll

	self assert: (authorDict defaultColorStates size = 2 ).
	self assert: authorDict highlightedColorStates size = 0.
	authorDict highlightAll.
	self assert: (authorDict defaultColorStates size = 0 ).
	self assert: authorDict highlightedColorStates size = 2.
	authorDict highlightNone.
	self assert: (authorDict defaultColorStates size = 2 ).
	self assert: authorDict highlightedColorStates size = 0.! !

TestCase subclass: #CHClassColorManagerTest
	instanceVariableNames: 'classes normalizer classDict colorState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHClassColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 10:47'!
setUp

	|methods colorState1|
	methods := OrderedCollection new.
	methods add: CHMethodHistTest1 new; 
		add: CHMethodHistTest2 new; 
		add: CHMethodHistTest3 new.
	classDict := CHClassColorManager create: (methods collect: #methodClass).
	colorState := classDict getDefaultColorStateFor: (CHMethodVisualization create: 		CHMethodHistTest1 new ).
	colorState1 := classDict getDefaultColorStateFor: (CHMethodVisualization create: 		CHMethodHistTest2 new).! !

!CHClassColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 09:49'!
testColor

	self assert: ((classDict colorFor: (CHMethodVisualization create: CHMethodHistTest1 new)) = (Color r: 0.8 g: 0.56 b: 0.56) or: (classDict colorFor: (CHMethodVisualization create: CHMethodHistTest1 new)) = (Color r: 0.56 g: 0.8 b: 0.8)).! !

!CHClassColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 13:02'!
testKeys

	self assert: classDict keys = #('CHTestClass' 'CHTest2Class') asOrderedCollection.! !

!CHClassColorManagerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 10:53'!
testStates

	self assert: (classDict defaultColorStates size = 2).
	self assert: (classDict highlightedColorStates size = 0).
	self assert: (classDict defaultColorStates includes: colorState ).
	colorState changeColor.
	self assert: (classDict defaultColorStates size=1).
	self assert: (classDict highlightedColorStates size = 1).
	self assert: (classDict defaultColorStates includes: colorState ) not.
	colorState := classDict highlightedColorStates asOrderedCollection at: 1.
	colorState changeColor.
	self assert: (classDict defaultColorStates size = 2).
	self assert: (classDict highlightedColorStates size = 0).! !

TestCase subclass: #CHColorManagerCommandTest
	instanceVariableNames: 'colorManagerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHColorManagerCommandTest commentStamp: '<historical>' prior: 0!
A CHColorManagerCommandTest is a test class for testing the behavior of CHColorManagerCommand!

!CHColorManagerCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 11:21'!
cleanIfNecessary
	colorManagerClass notNil
		ifTrue: [ colorManagerClass removeFromSystem ]! !

!CHColorManagerCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 11:56'!
createDummyColorManager

	^CHColorManager subclass: #CHDummyColorManager 
		instanceVariableNames: 'listenedValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ChisCommit-Interactions-Tests'.
	! !

!CHColorManagerCommandTest methodsFor: 'running' stamp: 'AlejandroInfante 1/30/2013 11:56'!
setUp

	self cleanIfNecessary.
	colorManagerClass := self createDummyColorManager.
	! !

!CHColorManagerCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 10:52'!
tearDown
	self cleanIfNecessary! !

CHColorManagerCommandTest subclass: #CHHighlightAllCommandTest
	instanceVariableNames: 'colorManager command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHHighlightAllCommandTest commentStamp: '<historical>' prior: 0!
A CHHighlightAllCommandTest is a test class for testing the behavior of CHHighlightAllCommand!

!CHHighlightAllCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 11:36'!
injectHighlightAllListener: aClass

	aClass compile: '
		initialize
		listenedValue := false.
		'.

	aClass compile: '
		highlightAll
		listenedValue := true.
		'.
	
	aClass compile:'
		isHighlightedAllReceived
		^listenedValue
		'.! !

!CHHighlightAllCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:45'!
setUp

	super setUp.
	self injectHighlightAllListener: colorManagerClass.
	colorManager := colorManagerClass new.
	command := CHHighlightAllCommand create: colorManager.! !

!CHHighlightAllCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 11:40'!
testExecute

	command execute.
	self assert: colorManager isHighlightedAllReceived.! !

CHColorManagerCommandTest subclass: #CHHighlightNoneCommandTest
	instanceVariableNames: 'colorManager command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHHighlightNoneCommandTest commentStamp: '<historical>' prior: 0!
A CHHighlightNoneCommandTest is a test class for testing the behavior of CHHighlightNoneCommand!

!CHHighlightNoneCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 11:42'!
injectHighlightNoneListener: aClass

	aClass compile: '
		initialize
		listenedValue := false.
		'.

	aClass compile: '
		highlightNone
		listenedValue := true.
		'.
	
	aClass compile:'
		isHighlightedNoneReceived
		^listenedValue
		'.! !

!CHHighlightNoneCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:45'!
setUp

	super setUp.
	self injectHighlightNoneListener: colorManagerClass.
	colorManager := colorManagerClass new.
	command := CHHighlightNoneCommand create: colorManager.! !

!CHHighlightNoneCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 11:41'!
testExecute

	command execute.
	self assert: colorManager isHighlightedNoneReceived.! !

CHColorManagerCommandTest subclass: #CHShuffleColorsCommandTest
	instanceVariableNames: 'colorManager command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHShuffleColorsCommandTest commentStamp: '<historical>' prior: 0!
A CHShuffleColorsCommandTest is a test class for testing the behavior of CHShuffleColorsCommand!

!CHShuffleColorsCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:48'!
injectShuffleColorWheelListener: aClass

	aClass compile: '
		initialize
		listenedValue := false.
		'.

	aClass compile: '
		shuffleColorWheel
		listenedValue := true.
		'.
	
	aClass compile:'
		isShuffleColorWheelReceived
		^listenedValue
		'.! !

!CHShuffleColorsCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:46'!
setUp

	super setUp.
	self injectShuffleColorWheelListener: colorManagerClass.
	colorManager := colorManagerClass new.
	command := CHShuffleColorsCommand create: colorManager.! !

!CHShuffleColorsCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:46'!
testExecute

	command execute.
	self assert: colorManager isShuffleColorWheelReceived.! !

TestCase subclass: #CHCommitVisualizationTest
	instanceVariableNames: 'stamp commitVisual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHCommitVisualizationTest commentStamp: '<historical>' prior: 0!
A ROCommitVisualizationTest is a test class for testing the behavior of ROCommitVisualization!

!CHCommitVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	stamp := CHTimeStamp createFromString: 'AlejandroInfante 1/8/2013 16:52'.
	commitVisual := CHCommitVisualization create: stamp.! !

!CHCommitVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/18/2013 15:59'!
testConstruction

	self assert: (commitVisual model = stamp ).
	self assert: (commitVisual numberOfInteractions = 1 ).
	self assert: (commitVisual numberOfShapes = 2).
	self assert: ((commitVisual getInteraction: ROPopup) text = 'AlejandroInfante 1/8/2013 16:52' ).
	self assert: ((commitVisual shapes at:1) isShapedAs: ROCircle).! !

TestCase subclass: #CHFilterCommandTest
	instanceVariableNames: 'filterManagerClass filterManager command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHFilterCommandTest commentStamp: '<historical>' prior: 0!
A CHFilterCommandTest is a test class for testing the behavior of CHFilterCommand!

!CHFilterCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 12:09'!
cleanIfNecessary
	filterManagerClass notNil
		ifTrue: [ filterManagerClass removeFromSystem ]! !

!CHFilterCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 12:26'!
createDummyFilterManager

	|class|
	class := CHColorManager subclass: #CHDummyFilterManager 
		instanceVariableNames: 'listenedSubscribe listenedUnsubscribe'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ChisCommit-Interactions-Tests'.
	class compile: '
		initialize
		listenedSubscribe := false.
		listenedUnsubscribe := false.
		'.	
	^class.! !

!CHFilterCommandTest methodsFor: 'running' stamp: 'AlejandroInfante 1/30/2013 12:24'!
injectHighlightAllListener

	filterManagerClass compile: '
		highlightAll
		listenedValue := true.
		'.
	filterManagerClass compile:'
		isHighlightedAllReceived
		^listenedValue
		'.! !

!CHFilterCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 12:36'!
injectSubscribeListener

	filterManagerClass compile: '
		subscribe: aFilterCommand
		aFilterCommand isNil ifFalse:[listenedSubscribe := true].
		'.
	filterManagerClass compile:'
		isSubscribeReceived
		^listenedSubscribe
		'.! !

!CHFilterCommandTest methodsFor: 'util' stamp: 'AlejandroInfante 1/30/2013 12:36'!
injectUnsubscribeListener

	filterManagerClass compile: '
		unsubscribe: aFilterCommand
		aFilterCommand isNil ifFalse:[listenedUnsubscribe := true].
		'.
	filterManagerClass compile:'
		isUnsubscribeReceived
		^listenedUnsubscribe
		'.! !

!CHFilterCommandTest methodsFor: 'running' stamp: 'AlejandroInfante 1/30/2013 12:45'!
setUp

	self cleanIfNecessary.
	filterManagerClass := self createDummyFilterManager.
	self injectSubscribeListener.
	self injectUnsubscribeListener.
	filterManager := filterManagerClass new.
	command := CHFilterCommand create: filterManager.! !

!CHFilterCommandTest methodsFor: 'running' stamp: 'AlejandroInfante 1/30/2013 11:54'!
tearDown
	self cleanIfNecessary! !

!CHFilterCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:34'!
testExecute

	command execute.
	self assert: filterManager isSubscribeReceived.! !

!CHFilterCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 12:36'!
testRevert

	command revert.
	self assert: filterManager isUnsubscribeReceived.! !

TestCase subclass: #CHFilterHighlightedCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHFilterHighlightedCommandTest commentStamp: '<historical>' prior: 0!
A CHFilterHighlightedCommandTest is a test class for testing the behavior of CHFilterHighlightedCommand!

!CHFilterHighlightedCommandTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/30/2013 15:17'!
testFilterBlock

	| command elem |
	command := CHFilterHighlightedCommand new.
	elem := CHMethodVisualization create: 
		(CHMethodHistory new method: (Object compiledMethodAt: #hash)).
	elem colorState: CHHighlightedColorState new.
	self deny: (command filterBlock value: elem).
	elem colorState: CHDefaultColorState new.
	self assert: (command filterBlock value: elem).! !

TestCase subclass: #CHFilterTestCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHFilterTestCommandTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/30/2013 15:06'!
testFilterBlock

	| command elem1 elem2 |
	command := CHFilterTestsCommand new.
	elem1 := CHMethodVisualization create: 
		(CHMethodHistory new method: (CHFilterCommandTest compiledMethodAt: #setUp)).
	elem2 := CHMethodVisualization create: 
		(CHMethodHistory new method: (Object compiledMethodAt: #hash)).
	self assert: (command filterBlock value: elem1).
	self deny: (command filterBlock value: elem2).! !

TestCase subclass: #CHHourTimeRulerTest
	instanceVariableNames: 'normalizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHHourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 11:18'!
setUp

	normalizer := CHTestUtils getInstance getTestNormalizer.! !

!CHHourTimeRulerTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 11:59'!
testConstruction

	|ruler realPositions testPositions |
	ruler := CH12HourTimeRuler create: normalizer.
	self assert: (ruler beginingDate = '3/2/2013 11:56' ).
	self assert: (ruler endingDate = '3/6/2013 11:56' ).
	realPositions := ruler marks collect:[:each | each position x].
	testPositions := (0 to: 7 ) collect: [:each |  normalizer roValue: (3539689200 + (each * 12 * 3600))].
	self assert: (realPositions = testPositions asOrderedCollection).
	! !

TestCase subclass: #CHMenuLoaderTest
	instanceVariableNames: 'view menuLoader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 10:56'!
setUp

	view := ROMondrianViewBuilder view: ROView new.
	menuLoader := CHMenuLoader new.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 11:26'!
testAuthorColorButtonOn

	|models|
	menuLoader authorColorButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Author Color'.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 11:36'!
testClassColorButtonOn

	|models|
	menuLoader classColorButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Class Color'.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:25'!
testFilterButtonOn

	|models|
	menuLoader filterButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Filter'.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:40'!
testPopulateMenuOn

	|oldElem|
	oldElem := view stack elements size.
	menuLoader populateMenuOn: view.
	view populateMenuOn: view stack.
	self assert: view stack elements size = (oldElem + 7).! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:16'!
testSortElementsButtonOn

	|models|
	menuLoader sortElementsButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Sort Elements'.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 11:41'!
testZoomInButtonOn

	|models|
	menuLoader zoomInButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Zoom in'.! !

!CHMenuLoaderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 11:41'!
testZoomOutButtonOn

	|models|
	menuLoader zoomOutButtonOn: view.
	view populateMenuOn: view stack.
	models := view stack elements collect: #model.
	self assert: (models at: 1)= 'Zoom out'.! !

TestCase subclass: #CHMethodHistoryTest
	instanceVariableNames: 'class selector methodVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:35'!
setUp

	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	methodVersions := CHMethodHistory analyzeSelector: selector in: class.! !

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/7/2013 18:18'!
tearDown

	class removeFromSystem.! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/24/2013 14:46'!
testAsString

	self assert: ('ROVersioningTestClass>>myExample' = methodVersions asString).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:35'!
testCommitTimeStamps
	
	self assert:  methodVersions commitTimeStamps size = 3.
	
	methodVersions := CHMethodHistory analyzeMethod: (class compiledMethodAt: selector).
	self assert: methodVersions commitTimeStamps size = 3.
	self assert: ((methodVersions commitTimeStamps first) = (class compiledMethodAt: selector)	timeStamp).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 12:14'!
testLastCommit

	self assert:( methodVersions lastCommit = methodVersions commitTimeStamps first).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 15:59'!
testMethodClass

	self assert: (methodVersions methodClass = 'ROVersioningTestClass').! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/15/2013 15:57'!
testMethodName

	self assert: (methodVersions methodName = selector asString).! !

TestCase subclass: #CHMethodVisualizationTest
	instanceVariableNames: 'methodHist methodVisual builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 16:04'!
setUp

	methodHist := CHMethodHistTest1 new.
	methodVisual := CHMethodVisualization create: methodHist.
	builder := CHVersionsBuilder new setUp: {CHMethodHistTest1 new}.
	builder setUpManagerClass: CHTestUtils getInstance getTestClassColorManager author: CHTestUtils getInstance getTestClassColorManager.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 14:48'!
testConstruction

	self assert: (methodVisual model = methodHist).
	self assert: (methodVisual numberOfShapes = 2 ).
	self assert: (methodVisual numberOfInteractions = 1 ).
	self assert: ((methodVisual shapes at:1) isShapedAs: ROBox).
	self assert: ((methodVisual shapes at:1) color = Color veryLightGray).! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 09:17'!
testDrawCommits

	|commits|
	commits := methodHist commitTimeStamps.
	self assert:(methodVisual numberOfElements = 0).
	methodVisual drawCommits: (builder).
	self assert:(methodVisual numberOfElements = 3).! !

TestCase subclass: #CHSortByAntiqueCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHSortByAntiqueCommandTest commentStamp: '<historical>' prior: 0!
A CHSortByAntiqueCommandTest is a test class for testing the behavior of CHSortByAntiqueCommand!

!CHSortByAntiqueCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 15:32'!
testSortingBlock

	| command elem1 elem2 |
	command := CHSortByAntiqueCommand new.
	elem1 := CHMethodVisualization create: 
		(CHMethodHistTest1 new).
	elem2 := CHMethodVisualization create: 
		(CHMethodHistTest2 new).
	self deny: (command sortingBlock value: elem1 value:elem2).! !

TestCase subclass: #CHSortByCommitsNumberCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions-Tests'!

!CHSortByCommitsNumberCommandTest commentStamp: '<historical>' prior: 0!
A CHSortByCommitsNumberCommandTest is a test class for testing the behavior of CHSortByCommitsNumberCommand!

!CHSortByCommitsNumberCommandTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 15:44'!
testSortingBlock

	| command elem1 elem2 |
	command := CHSortByCommitsNumberCommand new.
	elem1 := CHMethodVisualization create: 
		(CHMethodHistory analyzeSelector: #== in: ProtoObject).
	elem2 := CHMethodVisualization create: 
		(CHMethodHistTest2 new).
	self deny: (command sortingBlock value: elem1 value:elem2).! !

TestCase subclass: #CHTimeStampTest
	instanceVariableNames: 'parsedStamp method stamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHTimeStampTest commentStamp: '<historical>' prior: 0!
A ROTimeStampTest is a test class for testing the behavior of ROTimeStamp!

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 11:43'!
createMethod
	
	|class selector|
	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	^ (class compiledMethodAt: selector).	! !

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 12:10'!
createStamp

	^ (VersionsBrowser new 
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector) list first.! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:36'!
setUp

	method := self createMethod.
	stamp := self createStamp.
	parsedStamp := CHTimeStamp createFromString: stamp.
	
! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/8/2013 11:47'!
tearDown
	
	method methodClass removeFromSystem.! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:32'!
testAsString

	self assert: parsedStamp asString = method timeStamp .! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 11:48'!
testAuthor

	self assert: (parsedStamp author = method author ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 09:22'!
testDate

	self assert: (parsedStamp date = method timeStamp substrings second asDate ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:30'!
testEquals

	self assert:(parsedStamp = method timeStamp).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 17:23'!
testTime

	self assert: (parsedStamp time = method timeStamp substrings third asTime ).! !

TestCase subclass: #CHToogledStateTest
	instanceVariableNames: 'dummyMasterClass dummyCommandClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHToogledStateTest commentStamp: '<historical>' prior: 0!
A CHToogledStateTest is a test class for testing the behavior of CHToogledState!

CHToogledStateTest subclass: #CHToogledOffStateTest
	instanceVariableNames: 'master command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHToogledOffStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:13'!
injectExecuteListener
	
	dummyCommandClass compile: '
	execute
	listenedValue := true.
	'.
	dummyCommandClass compile: '
	isExecuteReceived
	^listenedValue
	'.! !

!CHToogledOffStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:12'!
setUp

	super setUp.
	master := dummyMasterClass new.
	self injectExecuteListener.
	command := dummyCommandClass new.
	! !

!CHToogledOffStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:13'!
testChangeState

	| state |
	state := CHToogledOffState create: master.
	state changeState: command.
	self assert: command isExecuteReceived.
	self assert: (master isStateReceived isKindOf: CHToogledOnState).! !

CHToogledStateTest subclass: #CHToogledOnStateTest
	instanceVariableNames: 'master command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI-Tests'!

!CHToogledOnStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:13'!
injectRevertListener
	
	dummyCommandClass compile: '
	revert
	listenedValue := true.
	'.
	dummyCommandClass compile: '
	isRevertReceived
	^listenedValue
	'.! !

!CHToogledOnStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:15'!
setUp

	super setUp.
	master := dummyMasterClass new.
	self injectRevertListener.
	command := dummyCommandClass new.
	! !

!CHToogledOnStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:12'!
testChangeState

	| state |
	state := CHToogledOnState create: master.
	state changeState: command.
	self assert: command isRevertReceived.
	self assert: (master isStateReceived isKindOf: CHToogledOffState).! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:34'!
cleanDummyCommand
	dummyCommandClass isNil
		ifFalse: [ dummyCommandClass removeFromSystem ]! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:33'!
cleanDummyMaster
	dummyMasterClass isNil
		ifFalse: [ dummyMasterClass removeFromSystem ]! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:42'!
createDummyCommand

	|class|
	class := CHRevertibleCommand subclass: #CHDummyCommand
		instanceVariableNames: 'listenedValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ChisCommit-GUI-Tests'.
	class compile:'
	initialize
	listenedValue := false.
	'.
	^class.! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:49'!
createDummyMaster

	|class|
	class := CHToggleableMenuButton subclass: #CHDummyMaster
		instanceVariableNames: 'listenedValue'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ChisCommit-GUI-Tests'.
	class compile:'
	initialize
	listenedValue := nil.
	'.
	^class.! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 17:12'!
injectMasterListener

	dummyMasterClass compile: '
	state: anObject
	listenedValue := anObject.
	'.
	dummyMasterClass compile: '
	isStateReceived
	^listenedValue.
	'.! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:17'!
setUp

	dummyMasterClass := self createDummyMaster.
	self injectMasterListener.
	dummyCommandClass := self createDummyCommand.
	! !

!CHToogledStateTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 16:34'!
tearDown
	self cleanDummyMaster.
	self cleanDummyCommand! !

TestCase subclass: #CHVersionVisualizationTest
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionVisualizationTest commentStamp: '<historical>' prior: 0!
A ROVersionVisualizationTest is a test class for testing the behavior of ROVersionVisualization!

!CHVersionVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	visualization := CHVersionVisualization new.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/14/2013 10:35'!
testAddAllMethodHistory

	| collection |
	collection := OrderedCollection new.
	collection add: (CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization).
	collection add: (CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization).

	self assert: visualization methodsHistory size = 0.	
	visualization addAllMethodHistory: collection.
	self assert: visualization methodsHistory size = 2.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:37'!
testAddMethodHistory

	| method1 method2 |
	method1 := CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization.
	method2 := CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization.

	self assert: visualization methodsHistory size = 0.	
	visualization addMethodHistory: method1.
	self assert: visualization methodsHistory size = 1.
	visualization addMethodHistory: method2.
	self assert: visualization methodsHistory size = 2.! !

TestCase subclass: #CHVersionsBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionsBuilderTest commentStamp: '<historical>' prior: 0!
A ROVersionsBuilderTest is a test class for testing the behavior of ROVersionsBuilder!

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 16:15'!
setUp

	builder := CHVersionsBuilder new.
	builder setUpManagerClass: CHTestUtils getInstance getTestClassColorManager author: CHTestUtils getInstance getTestClassColorManager.! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 15:43'!
testBuildCommitVisualization

	|normalizer stamp1 context stamp2 x elem |
	context := OrderedCollection new.
	stamp1 := CHTimeStamp createFromString: 'AlejandroInfante 3/4/2013 11:56'.
	stamp2 := CHTimeStamp createFromString: 'AlejandroInfante 3/5/2013 11:56'.
	context add: (CHTimeStamp createFromString: 'AlejandroInfante 3/2/2013 11:56').
	context add: (CHTimeStamp createFromString: 'AlejandroInfante 3/6/2013 11:56').
	context add: stamp1.
	normalizer := ROValueLinearNormalizer inContext: 
		(context collect: [:each | each dateAndTime asSeconds]).
	normalizer maxScale: 400; minScale: 0.
	builder normalizer: normalizer.
	x := (builder buildCommitVisualization: stamp1) positionAsInteger x.
	elem := (builder buildCommitVisualization: stamp2).
	self assert: ( x = 200).
	self assert: ( elem positionAsInteger x = 300).! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 15:25'!
testBuildMethodVisualization

	|methodHistory elem |

	builder setUp: (
		{CHMethodHistTest1 . CHMethodHistTest2} collect: [:each | each new ]
		).
	methodHistory := CHMethodHistTest1 new.
	elem := builder buildMethodVisualization: methodHistory.
	self assert: (elem model = methodHistory).
	self assert: (elem width = 425 ).
	self assert: (elem position x = 400).
	self assert: (elem height = 3 ).
	! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 16:03'!
testSetUp

	|collection normalizer |
	collection := OrderedCollection new.
	collection add: CHMethodHistTest1 new; add: CHMethodHistTest2 new.
	normalizer := (builder setUp: collection) normalizer.
	self assert:((normalizer roValue: 3539861760) = 400).
	self assert:((normalizer roValue: 3539688960) = 0).
	self assert:((normalizer roValue: 3540034560) = 800).! !

Object subclass: #CHColorManager
	instanceVariableNames: 'wheel keys color defaultColorStates highlightedColorStates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHColorManager subclass: #CHAuthorColorManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHAuthorColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 15:55'!
defaultColor

	^ Color gray.! !

!CHAuthorColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 14:42'!
getKey: anElement

	^anElement model author.! !

!CHAuthorColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 17:34'!
wheelInitialColor

	^ Color h:150 s: 0.9 v: 0.6.! !

CHColorManager subclass: #CHClassColorManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHClassColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 15:55'!
defaultColor

	^Color veryLightGray.! !

!CHClassColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:13'!
getKey: anElement

	^anElement model methodClass.! !

!CHClassColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 17:35'!
wheelInitialColor

	^ Color h: 0.0 s: 0.3 v: 0.8.! !

!CHColorManager class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 13:01'!
create: aCollection

	^ self new keys: aCollection.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:37'!
colorFor: anElement

	^wheel at: (keys indexOf: (self getKey: anElement) ) ifAbsent: self defaultColor.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 16:00'!
colorForKey: aKey

	^wheel at: (keys indexOf: aKey ) ifAbsent: self defaultColor.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 12:57'!
defaultColor

	self subclassResponsibility.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 10:42'!
defaultColorStates

	^defaultColorStates! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:59'!
getDefaultColorStateFor: anElement

	|state|
	state:= CHDefaultColorState withManager: self parent: anElement.
	defaultColorStates add: state.
	^state.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:01'!
getHighlightedColorStateFor: anElement

	|state|
	state:= CHHighlightedColorState withManager: self parent: anElement.
	highlightedColorStates add: state.
	^state.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 11:38'!
getKey: anElement

	self subclassResponsibility.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:50'!
highlightAll

	self defaultColorStates copy do: [:ea | ea changeHighlightedColor ].! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:51'!
highlightNone

	self highlightedColorStates copy do: [:ea | ea changeDefaultColor ].! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/21/2013 10:46'!
highlightedColorStates

	^highlightedColorStates! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:17'!
initialize

	defaultColorStates := Set new. 
	highlightedColorStates := Set new. ! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 14:33'!
invertColors

	|highlighted default|
	highlighted := self highlightedColorStates copy.
	default := self defaultColorStates copy.
	highlighted do: #changeColor.
	default do: #changeColor.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 12:52'!
keys

	^keys.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 14:42'!
keys: aCollection

	keys := aCollection removeDuplicates.
	self setWheel.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 14:33'!
refresh

	self invertColors.
	self invertColors.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 17:11'!
setWheel

	wheel := self wheelInitialColor wheel: keys size.
	self shuffleColorWheel.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 14:34'!
shuffleColorWheel

	wheel shuffle.
	self refresh.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:55'!
unsubscribeDefaultState: aState

	defaultColorStates remove: aState.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:55'!
unsubscribeHighlightedState: aState

	highlightedColorStates remove: aState.! !

!CHColorManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/17/2013 15:54'!
wheelInitialColor

	self subclassResponsibility.! !

Object subclass: #CHColorState
	instanceVariableNames: 'colorManager parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHColorState class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:34'!
withManager: aColorManager parent: anElement

	^self new withManager: aColorManager parent: anElement.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 11:53'!
changeColor

	self subclassResponsibility .! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:05'!
changeDefaultColor

	self unsubscribe.
	^ colorManager getDefaultColorStateFor: parent.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:06'!
changeHighlightedColor

	self unsubscribe.
	^ colorManager getHighlightedColorStateFor: parent.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:58'!
isHighlighted

	self subclassResponsibility.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:08'!
parent

	^parent.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:13'!
unsubscribe

	self subclassResponsibility.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:14'!
updateParentColor

	self subclassResponsibility.! !

!CHColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:19'!
withManager: aManager parent: anElement

	colorManager := aManager.
	parent := anElement.
	parent colorState: self.
	self updateParentColor.! !

CHColorState subclass: #CHDefaultColorState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHDefaultColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:23'!
changeColor

	^ self changeHighlightedColor.! !

!CHDefaultColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:15'!
changeDefaultColor

	^ self.! !

!CHDefaultColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 13:01'!
isHighlighted

	^false.! !

!CHDefaultColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:14'!
unsubscribe

	colorManager unsubscribeDefaultState: self.! !

!CHDefaultColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:15'!
updateParentColor

	parent color: colorManager defaultColor.! !

CHColorState subclass: #CHHighlightedColorState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHHighlightedColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:15'!
changeColor

	^ self changeDefaultColor.! !

!CHHighlightedColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:16'!
changeHighlightedColor

	^ self.! !

!CHHighlightedColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:58'!
isHighlighted

	^true.! !

!CHHighlightedColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 12:14'!
unsubscribe

	colorManager unsubscribeHighlightedState: self.! !

!CHHighlightedColorState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 13:15'!
updateParentColor

	parent color: (colorManager colorFor: parent).! !

Object subclass: #CHCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

CHCommand subclass: #CHColorManagerCommand
	instanceVariableNames: 'colorManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHColorManagerCommand class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:35'!
create: aColorManager

	^self new colorManager: aColorManager.! !

!CHColorManagerCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:36'!
colorManager: aColorManager

	colorManager := aColorManager.! !

CHColorManagerCommand subclass: #CHHighlightAllCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHHighlightAllCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:38'!
execute

	colorManager highlightAll.! !

CHColorManagerCommand subclass: #CHHighlightNoneCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHHighlightNoneCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:38'!
execute

	colorManager highlightNone.! !

CHColorManagerCommand subclass: #CHShuffleColorsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHShuffleColorsCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 14:25'!
execute

	colorManager shuffleColorWheel.! !

!CHCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 12:33'!
execute

	self subclassResponsibility.! !

CHCommand subclass: #CHRevertibleCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

CHRevertibleCommand subclass: #CHFilterCommand
	instanceVariableNames: 'filterManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHFilterCommand class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:39'!
create: aFilterManager

	^self new filterManager: aFilterManager.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:45'!
= anObject

	^ anObject class = self class and: anObject filterManager = self filterManager! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:43'!
execute

	filterManager subscribe: self.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:44'!
filterBlock

	"The block should accept if the element should be removed"
	self subclassResponsibility.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/25/2013 09:49'!
filterManager

	^filterManager! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:41'!
filterManager: aFilterManager

	filterManager := aFilterManager.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/25/2013 09:50'!
hash

	^ self class hash + filterManager hash.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:32'!
isApplied

	^self filterManager contains: self.! !

!CHFilterCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:43'!
revert

	filterManager unsubscribe: self.! !

CHFilterCommand subclass: #CHFilterHighlightedCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHFilterHighlightedCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:57'!
filterBlock

	^ [:ea | ea colorState isHighlighted not]! !

CHFilterCommand subclass: #CHFilterTestsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHFilterTestsCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:53'!
filterBlock

	^ [:ea | ea model method methodClass inheritsFrom: TestCase ]! !

!CHRevertibleCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:42'!
revert

	self subclassResponsibility.! !

CHCommand subclass: #CHSortCommand
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

CHSortCommand subclass: #CHSortByAntiqueCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHSortByAntiqueCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 18:01'!
sortingBlock

	^[: arg1 :arg2 | arg1 model firstCommit dateAndTime < arg2 model firstCommit dateAndTime].! !

CHSortCommand subclass: #CHSortByClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHSortByClassCommand class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 09:58'!
create: aController

	^(super create: aController rawView) controller: aController.! !

!CHSortByClassCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 09:58'!
sortingBlock

	|classOrder|
	classOrder := controller methodsHistory.
	^[: arg1 :arg2 | (classOrder indexOf: arg1 model) < (classOrder indexOf: arg2 model)].! !

CHSortCommand subclass: #CHSortByCommitsNumberCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHSortByCommitsNumberCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 18:10'!
sortingBlock

	^[: arg1 :arg2 | arg1 model commitTimeStamps size > arg2 model commitTimeStamps size].! !

!CHSortCommand class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:29'!
create: aController
	^self new controller: aController.! !

!CHSortCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:27'!
controller: aController

	controller := aController.! !

!CHSortCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:28'!
execute

	controller rawView sortElementsWith: self sortingBlock.
	controller applyLayout.! !

!CHSortCommand methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:32'!
sortingBlock

	self subclassResponsibility.! !

Object subclass: #CHMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

CHMenuEvent subclass: #CHAuthorColorsMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHAuthorColorsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:41'!
changeMenu: aMenu

	aMenu changeMenu: CHAuthorColorsMenu.! !

!CHAuthorColorsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:45'!
visitAuthorColorsMenu: aMenu

	aMenu changeMenu: CHNullMenu.! !

CHMenuEvent subclass: #CHClassColorsMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHClassColorsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:43'!
changeMenu: aMenu

	aMenu changeMenu: CHClassColorsMenu.! !

!CHClassColorsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:43'!
visitClassColorsMenu: aMenu

	aMenu changeMenu: CHNullMenu.! !

CHMenuEvent subclass: #CHFilterMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHFilterMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:35'!
changeMenu: aMenu

	aMenu changeMenu: CHFilterMenu.! !

!CHFilterMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:27'!
visitFilterMenu: aMenu

	aMenu changeMenu: CHNullMenu.! !

CHMenuEvent subclass: #CHInfoMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHInfoMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:45'!
changeMenu: aMenu

	aMenu changeMenu: CHInfoMenu.! !

!CHInfoMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:47'!
visitInfoMenu: aMenu

	aMenu changeMenu: CHNullMenu.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:38'!
visit: anElement

	anElement visit: self.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:45'!
visitAuthorColorsMenu: anElement

	self changeMenu: anElement.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:44'!
visitClassColorsMenu: anElement

	self changeMenu: anElement.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:27'!
visitFilterMenu: anElement

	self changeMenu: anElement.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:44'!
visitInfoMenu: anElement

	self changeMenu: anElement.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:33'!
visitNullMenu: anElement

	self changeMenu: anElement.! !

!CHMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:20'!
visitSortElementsMenu: anElement

	self changeMenu: anElement.! !

CHMenuEvent subclass: #CHSortElementsMenuEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Interactions'!

!CHSortElementsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:23'!
changeMenu: aMenu

	aMenu changeMenu: CHSortElementsMenu.! !

!CHSortElementsMenuEvent methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:20'!
visitSortElementsMenu: aMenu

	aMenu changeMenu: CHNullMenu.! !

Object subclass: #CHMenuLoader
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHMenuLoader class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:57'!
create: aController

	^self new controller: aController.! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:46'!
authorColorButtonOn: aView

	aView addMenu: 'Author Color' callBack: [CHAuthorColorsMenuEvent new visit: controller activeMenu].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 17:46'!
classColorButtonOn: aView

	aView addMenu: 'Class Color' callBack: [CHClassColorsMenuEvent new visit: controller activeMenu].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/22/2013 16:55'!
controller: aController

	controller := aController.! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 11:28'!
filterButtonOn: aView

	aView addMenu: 'Filter' callBack: [CHFilterMenuEvent new visit: controller activeMenu.].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:39'!
infoButtonOn: aView

	aView addMenu: 'Info' callBack: [CHInfoMenuEvent new visit: controller activeMenu.].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 11:38'!
populateMenuOn: aView

	self zoomInButtonOn: aView.
	self zoomOutButtonOn: aView.
	self authorColorButtonOn: aView.
	self classColorButtonOn: aView.
	self filterButtonOn: aView.
	self sortElementsButtonOn: aView.
	self infoButtonOn: aView.
	
	aView raw translateBy: 0 @ 30.! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/23/2013 17:22'!
sortElementsButtonOn: aView

	aView addMenu: 'Sort Elements' callBack: [CHSortElementsMenuEvent new visit: controller activeMenu.].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 10:19'!
zoomInButtonOn: aView

	aView addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].! !

!CHMenuLoader methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 10:20'!
zoomOutButtonOn: aView

	aView addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].! !

Object subclass: #CHMethodHistory
	instanceVariableNames: 'method list changeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodHistory commentStamp: '<historical>' prior: 0!
This class encapsulate the all the versions of a method.!

CHMethodHistory subclass: #CHMethodHistTest1
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/10/2013 17:30'!
commitTimeStamps
	^ (#('AlejandroInfante 3/5/2013 11:56' 'AlejandroInfante 3/4/2013 23:56' 'AlejandroInfante 3/4/2013 11:56') collect: [:each | CHTimeStamp createFromString: each])asOrderedCollection .! !

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 16:13'!
methodClass

	^'CHTestClass'.! !

!CHMethodHistTest1 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 14:48'!
methodName

	^'method1'.! !

CHMethodHistory subclass: #CHMethodHistTest2
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/11/2013 11:57'!
commitTimeStamps
	^ (#('AlejandroInfante 3/6/2013 11:56' 'AlejandroInfante 3/4/2013 11:56' 'AlejandroInfante 3/2/2013 11:56') collect: [:each | CHTimeStamp createFromString: each]) asOrderedCollection .! !

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 11:10'!
methodClass

	^'CHTest2Class'.! !

!CHMethodHistTest2 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 14:48'!
methodName

	^'method2'.! !

CHMethodHistory subclass: #CHMethodHistTest3
	instanceVariableNames: 'classMethodHist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodHistTest3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 17:13'!
commitTimeStamps
	^ (#('AlejandroInfante 3/5/2013 11:56' 'AlejandroInfante 3/4/2013 23:56' 'AlejandroInfante 3/4/2013 11:56') collect: [:each | CHTimeStamp createFromString: each])asOrderedCollection .! !

!CHMethodHistTest3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/15/2013 17:14'!
methodClass

	^'CHTest2Class'.! !

!CHMethodHistTest3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 14:48'!
methodName

	^'method3'.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod:method

	 ^ self new analyzeMethod: method.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:36'!
analyzeSelector: selector in: class

	^self analyzeMethod: (class compiledMethodAt: selector).! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/31/2013 11:17'!
= aMethodHist

	^self method = aMethodHist method.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/30/2013 14:59'!
analyzeMethod: newMethod

	self method: newMethod.
	self initializeList.
	^self.
	! !

!CHMethodHistory methodsFor: 'converting' stamp: 'AlejandroInfante 1/23/2013 18:18'!
asString

	^ self methodClass , '>>' , self methodName! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/11/2013 10:04'!
commitTimeStamps

	^list copy.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 18:05'!
firstCommit

	^ self commitTimeStamps last.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/31/2013 15:12'!
initializeList

	|changeSet|
	
	changeSet  := VersionsBrowser new
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector.
	changeList := changeSet changeList.
	list := OrderedCollection new.
	changeList do: [:elem | [list add: (CHTimeStamp createFromString: elem stamp)] on: Error do: [ ]
		].! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/31/2013 13:01'!
isValid

	^self commitTimeStamps notEmpty.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 18:06'!
lastCommit

	^ self commitTimeStamps first.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/21/2013 15:04'!
method

	^method.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/30/2013 14:58'!
method: aMethod

	method := aMethod.
	! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfanteTest 1/16/2013 14:58'!
methodClass

	"Probando con nuevos autores "
	^method methodClass asString.! !

!CHMethodHistory methodsFor: 'accessing' stamp: 'AlejandroInfante 1/14/2013 09:33'!
methodName

	^method selector asString.! !

Object subclass: #CHTestUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHTestUtils class
	instanceVariableNames: 'instance'!

CHTestUtils class
	instanceVariableNames: 'instance'!

!CHTestUtils class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 10:44'!
getInstance

	instance isNil ifTrue:[instance := self new.].
	^instance.! !

!CHTestUtils methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 16:11'!
getTestClassColorManager

	^CHClassColorManager create: OrderedCollection new.! !

!CHTestUtils methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/14/2013 11:18'!
getTestNormalizer

	| normalizer |
	normalizer := ROValueLinearNormalizer inContext: #(3539688960 3540034560).
	normalizer minScale: 0; maxScale: 800.
	^normalizer.! !

Object subclass: #CHTimeRulerFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHTimeRulerFactory methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 18:02'!
createTimeRuler: methodNormalizer

	|ruler|
	ruler := CH12HourTimeRuler create: methodNormalizer.
	ruler width: 825.
	ruler resizeStrategy: ROFixedSizedParent instance.
	^ruler.! !

Object subclass: #CHTimeStamp
	instanceVariableNames: 'author date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHTimeStamp commentStamp: '<historical>' prior: 0!
This class encapsulate a TimeStamp generated by a commit, allowing to retrieve the information easily.!

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 12:00'!
createFromAuthor: author date: date time: time

	^ self new setAuthor: author date: date time: time.! !

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/31/2013 14:48'!
createFromString: timeStamp

	| parts |
	"Working on the reverse of the stamp is for fixing the names that has spaces on them "
	parts := timeStamp substrings reverse.
	^self createFromAuthor: parts third date: parts second time: parts first.! !

!CHTimeStamp methodsFor: 'comparing' stamp: 'AlejandroInfante 1/8/2013 12:32'!
= aStringOrStamp

	^ aStringOrStamp = self asString.! !

!CHTimeStamp methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 17:49'!
asString
	
	^ self author,' ',self date mmddyyyy,' ', time! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:59'!
author

	^author! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/8/2013 12:16'!
date

	^date.! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/10/2013 11:59'!
dateAndTime

	^ DateAndTime date: self date time: self time.! !

!CHTimeStamp methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/9/2013 17:49'!
setAuthor: newAuthor date: newDate time: newTime
	
	author:= newAuthor.
	date:= newDate asDate.
	time:= newTime.
	
	^self

	! !

!CHTimeStamp methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 17:48'!
time

	^time asTime.! !

Object subclass: #CHToogledState
	instanceVariableNames: 'master'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

CHToogledState class
	instanceVariableNames: 'master'!

CHToogledState class
	instanceVariableNames: 'master'!

CHToogledState subclass: #CHToogledOffState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHToogledOffState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:51'!
changeState

	master state: (CHToogledOnState create: master).! !

!CHToogledOffState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:01'!
color

	^Color black.! !

!CHToogledOffState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:41'!
runCommand: command

	command execute.! !

CHToogledState subclass: #CHToogledOnState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-GUI'!

!CHToogledOnState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:51'!
changeState

	master state: (CHToogledOffState create: master).! !

!CHToogledOnState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:01'!
color

	^Color green.! !

!CHToogledOnState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:41'!
runCommand: command

	command revert.! !

!CHToogledState class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:50'!
create: aMaster

	^self new master:aMaster.! !

!CHToogledState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:39'!
changeState

	self subclassResponsibility.! !

!CHToogledState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:51'!
changeState: aCommand

	self runCommand: aCommand.
	self changeState.! !

!CHToogledState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:00'!
color

	self subclassResponsibility.! !

!CHToogledState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:50'!
master: aMaster

	master := aMaster.! !

!CHToogledState methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:40'!
runCommand: aCommand

	self subclassResponsibility.! !

Object subclass: #CHVersionVisualization
	instanceVariableNames: 'view rawView elements methods builder ruler authorColorMan classColorMan classNames methodInteraction commitInteraction activeMenu filterManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionVisualization commentStamp: '<historical>' prior: 0!
This class instantiate the Roassal view and is responsible of adding the elements!

!CHVersionVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/18/2013 17:04'!
analyzePackages: stringCollection

	^(self new analyzePackages: (stringCollection collect: [:ea | PackageInfo named: ea])) launch! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/22/2013 15:40'!
activeMenu

	^activeMenu.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/22/2013 16:49'!
activeMenu: aMenu

	activeMenu := aMenu.
	view stack add: aMenu.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/14/2013 10:30'!
addAllMethodHistory: aCollection

	aCollection do: [:each | self addMethodHistory: each ]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/21/2013 15:11'!
addInteractionsToMethods

	elements do: [:ea | ea @ (CHChangeColorToClass initializeWithController: self)].
	elements do: [:ea |
		|interaction|
		interaction := ROMenuActivable initializeElement: ea.
		interaction item: ea model methodClass , '>>' , ea model methodName action: [ ].
		interaction item: 'Browse' action: [:elem | elem model method browse].
		interaction item: 'Version Browser' action:[:elem | VersionsBrowser browseVersionsForClass: 			elem model method methodClass selector: elem model methodName asSymbol]
		].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/10/2013 11:44'!
addMethodHistory: methodHistory

	methods add: methodHistory.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 17:06'!
analyzePackage: aPackageInfo

	|packClasses packMethods|
	packClasses := aPackageInfo classes.
	classNames addAll: (packClasses collect:#name).
	packMethods := OrderedCollection new.
	packClasses do: [:ea |
		packMethods addAll: ea methods
		].
	self addAllMethodHistory: (packMethods collect: [:ea | CHMethodHistory analyzeMethod: ea])! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 16:46'!
analyzePackages: aPackageCollection

	aPackageCollection do: [:each | self analyzePackage: each ]! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/28/2013 17:19'!
applyLayout
	
	rawView elements size ~= 0 ifTrue:[
		(ROVerticalLineLayout new alignRight gapSize: 1) 
			translator: (CHSmoothLayoutTranslator create: 30); 
			applyOn: rawView elements].! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/23/2013 12:42'!
authorColorManager

	^authorColorMan.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/23/2013 12:41'!
classColorManager

	^classColorMan.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 15:42'!
drawCommits

	elements do: [:each | each drawCommits: builder].
	elements do: [:eaMethod | 
		eaMethod elements do: [:eaCommit |
			eaCommit @ (CHChangeColorToAuthor initializeWithController: self)
			]].! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/21/2013 15:12'!
drawMethods

	elements := methods collect: [:each | builder buildMethodVisualization: 
		each].
	self addInteractionsToMethods.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/18/2013 17:09'!
drawRuler

	ruler := builder buildTimeRuler.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/24/2013 12:45'!
filterManager

	^filterManager.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/31/2013 13:00'!
filterValidMethodHistories

	methods removeDuplicates.
	methods := methods select: #isValid.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/24/2013 12:45'!
initialize

	rawView := ROView new.
	view := ROMondrianViewBuilder view: rawView.
	methods := OrderedCollection new.
	elements := OrderedCollection new.
	builder := CHVersionsBuilder new.
	labels := OrderedCollection new.
	classNames := OrderedCollection new.
	filterManager := FilterManager create: self.
	self activeMenu: (CHNullMenu create: self).! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/28/2013 17:08'!
launch
	
	self setUp.
	self drawMethods.
	self drawCommits.
	rawView addAll: elements.
	self applyLayout.
	(CHMenuLoader create: self) populateMenuOn: view.
	view noLayout.
	rawView camera translateBy: -100 @ 0.
	view open.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/23/2013 09:57'!
menu

	^view stack elements select: [: ea | (ea = activeMenu) not]! !

!CHVersionVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/10/2013 11:45'!
methodsHistory

	^methods! !

!CHVersionVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/18/2013 15:23'!
methodsVisualization

	^elements.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/22/2013 16:26'!
rawView

	^rawView.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 13:11'!
setClassNames

	classNames := (methods collect: #methodClass)! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/31/2013 13:00'!
setUp

	self filterValidMethodHistories.
	self setClassNames.
	self setUpColorManagers.
	self setUpBuilder.
	builder setUp: methods.
	builder setUpManagerClass: classColorMan author: authorColorMan .! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 15:02'!
setUpBuilder

	builder setUp: methods.
	builder setUpManagerClass: classColorMan author: authorColorMan.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/18/2013 14:46'!
setUpColorManagers

	|stamps|
	stamps := OrderedCollection new.
	classColorMan := CHClassColorManager create: classNames.
	methods do: [:ea | stamps addAll: ea commitTimeStamps].
	authorColorMan := CHAuthorColorManager create: (stamps collect: #author).! !

Object subclass: #CHVersionsBuilder
	instanceVariableNames: 'methodNormalizer classColorMan authorColorMan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder commentStamp: '<historical>' prior: 0!
This is a builder of CHVersionElements for an easy creation of a nice visualization.
!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/30/2013 14:37'!
buildCommitVisualization: stamp

	|elem|
	elem := CHCommitVisualization create: stamp.
	elem colorState: (authorColorMan getDefaultColorStateFor: elem ).
	elem size: 3.
	elem translateTo: (methodNormalizer roValue: stamp dateAndTime asSeconds ) @ elem positionAsInteger y.
	^ elem.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/30/2013 15:25'!
buildMethodVisualization: methodHist

	|elem posX |
	elem :=CHMethodVisualization create: methodHist.
	elem colorState: (classColorMan getDefaultColorStateFor: elem ).
	posX := (methodNormalizer roValue: methodHist firstCommit dateAndTime asSeconds).
	elem width: 800 - posX +25.
	elem height: 3.
	elem translateBy: ( posX @ elem position y).
	^elem. ! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/15/2013 15:32'!
buildTimeRuler

	^CHTimeRulerFactory new createTimeRuler: methodNormalizer.! !

!CHVersionsBuilder methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:38'!
normalizer

	^methodNormalizer.! !

!CHVersionsBuilder methodsFor: 'accessing' stamp: 'AlejandroInfante 1/17/2013 15:38'!
normalizer: normalizer

	methodNormalizer := normalizer.! !

!CHVersionsBuilder methodsFor: 'setUp' stamp: 'AlejandroInfante 1/17/2013 15:43'!
setUp: aMethodHistCollection

	|commitCollection|
	commitCollection := OrderedCollection new.
	aMethodHistCollection do: [:each | commitCollection addAll: each commitTimeStamps].
	commitCollection := commitCollection collect: [:each | each dateAndTime asSeconds].
	methodNormalizer := ROValueLinearNormalizer inContext: commitCollection.
	methodNormalizer minScale: 0; maxScale: 800.! !

!CHVersionsBuilder methodsFor: 'setUp' stamp: 'AlejandroInfante 1/18/2013 12:50'!
setUpManagerClass: aClassMan author: aAuthorMan

	classColorMan := aClassMan.
	authorColorMan := aAuthorMan.! !

Object subclass: #ChisExample
	instanceVariableNames: 'visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Examples'!

!ChisExample methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/30/2013 13:01'!
initialize

	visual := CHVersionVisualization analyzePackages: #('ChisCommit').! !

Object subclass: #ChisExample2
	instanceVariableNames: 'visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Examples'!

!ChisExample2 methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/15/2013 10:35'!
getVisualization

	^visual.! !

!ChisExample2 methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/15/2013 10:37'!
initialize

	|methods|
	visual := CHVersionVisualization new.
	methods := CHVersionVisualization methods.
	visual addAllMethodHistory: (methods collect:[:each | CHMethodHistory analyzeMethod: each]).
	visual launch.! !

Object subclass: #ChisExample3
	instanceVariableNames: 'visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Examples'!

!ChisExample3 methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/16/2013 11:18'!
initialize

	|methods classes |
	visual := CHVersionVisualization new.
	classes := CHVersionVisualization package classes.
	methods := OrderedCollection new.
	classes collect: [:ea | methods addAll: ea methods ].
	visual addAllMethodHistory: (methods collect:[:each | CHMethodHistory analyzeMethod: each]).
	visual launch.! !

Object subclass: #FilterManager
	instanceVariableNames: 'filters controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

FilterManager class
	instanceVariableNames: 'controller'!

FilterManager class
	instanceVariableNames: 'controller'!

!FilterManager class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:51'!
create: aController

	^self new controller: aController.! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/25/2013 10:31'!
applyFilter: aFilter

	|view elementsToRemove |
	view := controller rawView.
	elementsToRemove := (view elements select: aFilter filterBlock).
	elementsToRemove do: #removeFromView.
! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 16:11'!
applyLayout

	controller applyLayout.! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 12:40'!
contains: aFilter

	^filters contains: [:ea | ea = aFilter].! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/24/2013 12:04'!
controller: aController

	controller := aController.! !

!FilterManager methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/24/2013 11:57'!
initialize

	filters := Set new.! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 15:49'!
subscribe: aFilter

	filters add: aFilter.
	self applyFilter: aFilter.
	self applyLayout.! !

!FilterManager methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/28/2013 17:24'!
unsubscribe: aFilter

	|view|
	view := controller rawView.
	filters remove: aFilter.
	view allElementsDo: #removeFromView.
	view addAll: controller methodsVisualization.
	filters do: [:ea | self applyFilter: ea].
	self applyLayout.! !
